=== modified file 'loggerhead/middleware/profile.py'
--- loggerhead/middleware/profile.py	2008-11-14 06:48:20 +0000
+++ loggerhead/middleware/profile.py	2009-03-30 15:51:18 +0000
@@ -3,6 +3,7 @@
 import threading
 
 from bzrlib.lsprof import profile
+from guppy import hpy
 
 class LSProfMiddleware(object):
     '''Paste middleware for profiling with lsprof.'''
@@ -31,3 +32,16 @@
         finally:
             self.lock.release()
 
+
+class MemoryProfileMiddleware(object):
+    '''Paste middleware for profiling memory with heapy.'''
+
+    def __init__(self, app):
+        self.app = app
+
+    def __call__(self, environ, start_response):
+        heap = hpy()
+        app = self.app(environ, start_response)
+        print heap.iso(app)
+        return app
+

=== modified file 'serve-branches'
--- serve-branches	2009-02-24 21:13:30 +0000
+++ serve-branches	2009-03-30 15:51:18 +0000
@@ -50,6 +50,9 @@
                             "(defaults to 8080)."))
     parser.add_option("--host", dest="user_host",
                       help="Host Loggerhead should listen on.")
+    parser.add_option('--memory-profile', action='store_true',
+                      dest='memory_profile',
+                      help='Profile the memory usage using heapy.')
     parser.add_option("--prefix", dest="user_prefix",
                       help="Specify host prefix.")
     parser.add_option("--profile", action="store_true", dest="profile",
@@ -122,6 +125,9 @@
     if options.profile:
         from loggerhead.middleware.profile import LSProfMiddleware
         app = LSProfMiddleware(app)
+    if options.memory_profile:
+        from loggerhead.middleware.profile import MemoryProfileMiddleware
+        app = MemoryProfileMiddleware(app)
 
     if not options.user_prefix:
         prefix = '/'

